<?php


####################################################################################
##-----CONFIGURATION

	$settings = parse_ini_file('d2kdsys/d2kconfig.ini', true);
	$humanscriptname = 'Gallery';
	$password = 'fakepassword';


####################################################################################
##-----SET

	$settings = $settings[$humanscriptname];
	$filesperpage = $settings['FilesPerPage'];
	$minimumpages = $settings['MinimumPages'];
	$showpagesunder = $settings['ShowPagesUnder'];

	$scriptname = $settings['ScriptName'];
	$scripttype = $settings['ScriptType'];
	$fileslocation = $settings['FilesLocation'];
	$domain = $settings['Domain'];
	$p2p = $settings['P2P'];

	$thumbsdir = $settings['ThumbsDir'];
	$thumbnailsize = $settings['ThumbnailSize'];
	$resizedwidth = $settings['ResizedWidth'];
	$resizedheight = $settings['ResizedHeight'];
	$watermark = $settings['Watermark'];
	$markplacement = $settings['MarkPlacement'];

	$starimage = "layout/{$style}/{$settings['StarImage']}";
	$halfstarimage = "layout/{$style}/{$settings['HalfStarImage']}";
	$submitimage = "layout/{$style}/{$settings['SubmitImage']}";

	$defaultauthor = $settings['DefaultAuthor'];
	$defaultdescription = $settings['DefaultDescription'];

	$pause = $settings['Pause'];
	$alternate = $settings['Alternate'];
	$sysstyle = $settings['Style'];
	$allowcomments = $settings['AllowComments'];


	$stfiles = 'file';
	if($scripttype == 'Gallery')
	{
		$stfiles = 'thumb';
	}


####################################################################################
##-----CHECK IF THE DIRECTORY EXISTS


	$currdir = $fileslocation;
	if(isset($_GET['s']) && $_GET['s'] !== '')
	{
		$currdir = "{$fileslocation}/{$_GET['c']}|Category/{$_GET['s']}|Subcategory";
		if(!is_dir($currdir))
		{
			$baddirmessage = "The category '{$_GET['c']} > {$_GET['s']}' does not exist.";
		}
	}
	elseif(isset($_GET['c']) && $_GET['c'] !== '')
	{
		$currdir = "{$fileslocation}/{$_GET['c']}|Category";
		if(!is_dir($currdir))
		{
			$baddirmessage = "The category '{$_GET['c']}' does not exist.";
		}
	}
	
	


####################################################################################
##-----ALL FUNCTIONS


	function makepath($c, $s, $p, $f, $m, $a)
	{
		global $scriptname;
		if($c != '')
		{
			$ca = "?c={$c}";
		}
		if($s != '')
		{
			$sa = "&s={$s}";
		}
		if($p != '')
		{
			if($c != '')
				$pa = "&p={$p}";
			else
				$pa = "?p={$p}";
		}
		if($f != '')
		{
			if($c != '' || $p != '')
				$fa = "&f={$f}";
			else
				$fa = "?f={$f}";
		}
		if($m != '')
		{
			$ma = "&m={$m}";
		}
		if($a != '')
		{
			$aa = "&a={$a}";
		}
		return "{$scriptname}.php{$ca}{$sa}{$pa}{$fa}{$ma}{$aa}";
	}

	function whatis($name){

		if(is_file($name))
			return 'File';
		elseif(substr_count($name, '|Category')>=1)
			return 'Category';
		elseif(substr_count($name, '|Subcategory')>=1)
			return 'Subcategory';
		else
			return 'Undesirable';
	}

	function getsize($file)
	{
		if(filesize($file) >= 1000000000)
			return round(filesize($file)/1000000000, 2) . " Gigabytes";
		elseif(filesize($file) >= 1000000)
			return round(filesize($file)/1000000, 2) . " Megabytes";
		elseif(filesize($file) >= 1000)
			return round(filesize($file)/1000, 2) . " Kilobytes";
		else
			return filesize . " Bytes";
	}

	function deep_in_array($value, $array) {
		foreach($array as $item) {
			if(!is_array($item)) {
				if ($item == $value) return true;
				else continue;
			}
	      
			if(in_array($value, $item)) return true;
			else if(deep_in_array($value, $item)) return true;
		}
		return false; 
	}


	function getcomments($subject)
	{
		global $fileslocation;
		global $commentcount;
		$allcomments = parse_ini_file("{$fileslocation}/log/comments.ini", true);
		$commentcount = count($allcomments);
		foreach($allcomments as $key => $value)
		{
			if($value['file'] == $subject)
			{
				$comments[] = $value;
				$comments[$key]['name'] = stripslashes($comments[$key]['name']);
				$comments[$key]['comment'] = stripslashes($comments[$key]['comment']);
			}
		}
		return($comments);
	}
	

####################################################################################
##-----FIND ALL FILES


	/*
	Lets go get the files!
	First, we need to check that no files are set to download, and then we can display a list.
	*/
	
	$mode = $_GET['m'];
	if($mode == '')
		{
		if(is_dir($currdir)){
			$allfiles = scandir($currdir);
			$baddir = false;
		}
		else
		{
			echo $baddirmessage;
			$baddir = true;
		}

		if(!$baddir)
		{

			foreach($allfiles as $key => $value)
			{
				if(whatis($value) == 'Category')
				{
					$value = explode('|', $value);
					$categories[] = $value[0];
				}
				elseif(whatis($value) == 'Subcategory')
				{
					$value = explode('|', $value);
					$subcategories[] = $value[0];
				}
				elseif(whatis("{$currdir}/{$value}") == 'File')
				{
					$files[] = $value;
				}
			}


####################################################################################
##-----PAGINATION


	$totalpages = ceil(count($files) / $filesperpage);
	if(isset($_GET['p']) && $_GET['p'] !== '' && $_GET['p'] <= $totalpages && $_GET['p'] >= 1)
		$currentpage = $_GET['p'];
	elseif($_GET['p'] > $totalpages)
		$currentpage = $totalpages;
	elseif($_GET['p'] < 1)
		$currentpage = 1;
	else
		$currentpage = 1;
	$previouspage = $currentpage - 1;
	$nextpage = $currentpage + 1;

	$filescap = $filesperpage * $currentpage;
	$filesstart = $filescap - $filesperpage;
	require("d2kdsys/styles/{$sysstyle}/pagination.inc");


####################################################################################
##-----LIST FILES


/*---------------------------------List Categories--------------------------------*/

			if(isset($categories))
			{
				foreach($categories as $key => $value)
				{
					$subcategorystuff = scandir("{$fileslocation}/{$value}|Category");
					$categorysubcats = array();
					$categorysubfiles = array();
					foreach($subcategorystuff as $subkey => $subvalue)
					{
						if(whatis($subvalue) == 'Subcategory')
						{
							$categorysubcats[] = $subvalue;
						}
						if(whatis("{$fileslocation}/{$value}|Category/{$subvalue}") == 'File')
						{
							$categorysubfiles[] = $subvalue;
						}
					}
					foreach($categorysubcats as $subkey => $subvalue)
					{
						$subcategoryfiles = scandir("{$fileslocation}/{$value}|Category/{$subvalue}");
						foreach($subcategoryfiles as $subcategorykey => $subcategoryfilename)
						{
							if(whatis("{$fileslocation}/{$value}|Category/{$subvalue}/{$subcategoryfilename}") == 'File')
							{
								$categorysubfiles[] = $subcategoryfilename;
							}
						}
					}
					$numcatfiles = count($categorysubfiles);
					if($numcatfiles >= 2)
					{
						if($scripttype == "Downloads")
						{
							$filesplural = 'files';
						}
						elseif($scripttype == "Gallery")
						{
							$filesplural = 'images';
						}
						$are = 'are';
					}
					else
					{
						if($scripttype == "Downloads")
						{
							$filesplural = 'file';
						}
						elseif($scripttype == "Gallery")
						{
							$filesplural = 'image';
						}
						$are = 'is';
					}
					require("d2kdsys/styles/{$sysstyle}/categories.inc");
				}
			}
			if(isset($categories) && isset($files))
			echo '<hr>';

/*-------------------------------List Subcategories-------------------------------*/

			if(isset($subcategories))
			{
				foreach($subcategories as $key => $value)
				{
					$subsubcatfiles = array();
					$subsubcategorystuff = scandir("{$fileslocation}/{$_GET['c']}|Category/{$value}|Subcategory");
					foreach($subsubcategorystuff as $subsubcatkey => $subsubcatname)
					{
						if(whatis("{$fileslocation}/{$_GET['c']}|Category/{$value}|Subcategory/{$subsubcatname}") == 'File')
						{
							$subsubcatfiles[] = $subsubcatname;
						}
					}
					$numsubsubcatfiles = count($subsubcatfiles);
					if($numsubsubcatfiles >= 2)
					{
						if($scripttype == "Downloads")
						{
							$filesplural = 'files';
							$are = 'are';
						}
						elseif($scripttype == "Gallery")
						{
							$filesplural = 'images';
							$are = 'are';
						}
					}
					else
					{
						if($scripttype == "Downloads")
						{
							$filesplural = 'file';
							$are = 'is';
						}
						elseif($scripttype == "Gallery")
						{
							$filesplural = 'image';
							$are = 'is';
						}
					}
					require("d2kdsys/styles/{$sysstyle}/subcategories.inc");
				}
			}

			if(isset($subcategories) && isset($files))
			echo '<hr>';

/*-----------------------------------List Files----------------------------------*/

			if(isset($files))
			{
				if(file_exists($fileslocation . '\groups\groups.txt'))
					$groups = file($fileslocation . '\groups\groups.txt');
				else
					$groups = array();
					
				foreach($files as $key => $value)
				{
					if($key<$filescap && $key>=$filesstart)
					{
						//Get the file's name
						if(file_exists("{$fileslocation}/info/{$value}-n.txt"))
						{
							$name = file_get_contents("{$fileslocation}/info/{$value}-n.txt");
						}
						else
						{
							$name = explode('.', $value);
							array_pop($name);
							$name = implode('.', $name);

						}
	
						//Get the file's rating
						if(file_exists("{$fileslocation}/log/{$value}-r.txt"))
						{
							$ratings = file("{$fileslocation}/log/{$value}-r.txt");
							$numratings = count($ratings);
							foreach($ratings as $ratekey => $rate)
							{
								$sum[$value] += $rate;
							}
							$rating = $sum[$value]/$numratings;
						}
						else
						{
							$rating = 0;
						}
						$starrating = '';
						$decimal = explode('.', $rating);
						for($i=0; $i<=$rating; $i++){
							if($i+1<=$rating && $i+1<=5)
								$starrating .= '<img src="' . $starimage . '" />';
							elseif($decimal[1]>0 && $i<5)
								$starrating .= '<img src="' . $halfstarimage . '" />';
						}

						if(file_exists($thumbsdir . '/' . $value . '_' . $thumbnailsize . '.png'))
						{
							$thumbnail = $thumbsdir . '/' . $value . '_' . $thumbnailsize . '.png';
						}
						else
						{
							$thumbnail = "rescale.php?d={$currdir}&i={$value}&r=0&w={$thumbnailsize}&h={$thumbnailsize}&t={$thumbsdir}";
						}


						if(!in_array($value, $groups))
						{
							require("d2kdsys/styles/{$sysstyle}/files.inc");
						}
					}
				}
			}
		}
		if($showpagesunder)
		{
			include("d2kdsys/styles/{$sysstyle}/pagination.inc");
		}
	}

	elseif($mode == 'details'){


####################################################################################
##-----SHOW FILE DETAILS


		$filename = $_GET['f'];
		$comments = @getcomments($filename);

/*--------------------------------Check Existance--------------------------------*/

	if(!file_exists("{$currdir}/{$filename}"))
	{
		$response = 'File does not exist<br \>';
	}

/*----------------------------------Make Changes---------------------------------*/

		if(isset($_POST['pass']))
		{
			if($_POST['pass'] == $password)
			{
				file_put_contents("{$fileslocation}/info/{$filename}-n.txt", $_POST['humanname']);
				file_put_contents("{$fileslocation}/info/{$filename}-a.txt", $_POST['author']);
				file_put_contents("{$fileslocation}/info/{$filename}-d.txt", $_POST['description']);
				$response = "Details edited successfully<br \>";
				if($_POST['delete'] == 'on')
				{
					unlink("{$currdir}/{$filename}");

					@unlink("{$fileslocation}/log/{$filename}.txt");
					@unlink("{$fileslocation}/log/{$filename}-r.txt");

					@unlink("{$fileslocation}/info/{$filename}-a.txt");
					@unlink("{$fileslocation}/info/{$filename}-d.txt");
					@unlink("{$fileslocation}/info/{$filename}-n.txt");
					$response = "{$filename} deleted successfully<br \>";
				}
			}
			elseif($_POST['pass'] == "")
			{
				$response = "Details not edited: Password not set<br \>";
			}
			elseif($_POST['pass'] != $pass)
			{
				$response = "Details not edited: Password incorrect<br \>";
			}
		}
			if($_POST['delete'] != 'on')
			{

/*----------------------------------Post Comment---------------------------------*/

		if($_GET['a'] == 'comment' && $_POST['comment'])
		{
			$newcomment = $commentcount;
			if($_POST['comment'] != $comments[$newcomment - 1]['comment'])
			{
				$inioutput = "\n[{$newcomment}]";
				$inioutput .= "\nfile=\"{$filename}\"";
				$inioutput .= "\ntitle=\"{$_POST['title']}\"";
				$inioutput .= "\ntime=".time();
				$inioutput .= "\nname=\"{$_POST['name']}\"";
				$inioutput .= "\nurl=\"{$_POST['url']}\"";
				$inioutput .= "\ncomment=\"{$_POST['comment']}\"";
				@file_put_contents("{$fileslocation}/log/comments.ini", $inioutput, FILE_APPEND);
				$comments = @getcomments($filename);
			}
		}

/*------------------------------------Get Name-----------------------------------*/

		$nametxt = "{$fileslocation}/info/{$filename}-n.txt";
		if(file_exists($nametxt))
		{
			$humanname = stripslashes(file_get_contents($nametxt));
		}
		else
		{
			$explodefilename = explode('.', $filename);
			$humanname = $explodefilename[0];
		}

/*------------------------------------Get Author---------------------------------*/

		$authortxt = "{$fileslocation}/info/{$filename}-a.txt";
		if(file_exists($authortxt))
		{
			$author = stripslashes(file_get_contents($authortxt));
		}
		else
		{
			$author = $defaultauthor;
		}

/*----------------------------------Delete File----------------------------------*/

		$descriptiontxt = "{$fileslocation}/info/{$filename}-d.txt";
		if(file_exists($descriptiontxt))
		{
			$description = stripslashes(file_get_contents($descriptiontxt));
		}
		else
		{
			$description = $defaultdescription;
		}

/*-------------------------------Get Download Count------------------------------*/

		if(file_exists("{$fileslocation}/log/{$filename}.txt"))
		{
			$numdownloads = file_get_contents("{$fileslocation}/log/{$filename}.txt");
		}
		else
		{
			$numdownloads = 0;
		}
		if($scripttype == 'Gallery')
		{
			$numdownloads++;
			file_put_contents("{$fileslocation}/log/{$filename}.txt", $numdownloads);
			$downloads = 'Views';
			$ratethis = 'image';
		}
		elseif($scripttype == "Downloads")
		{
			$downloads = 'Downloads';
			$ratethis = 'file';
		}

/*-----------------------------------Get Ratings---------------------------------*/

		if(isset($_POST['rate']))
		{
			if($_POST['rate'] != "Best" and $_POST['rate'] != "Worst")
			{
				file_put_contents("{$fileslocation}/log/{$filename}-r.txt", $_POST['rate'] . "\n", FILE_APPEND);
			}
			elseif($_POST['rate'] == "Best")
			{
				file_put_contents("{$fileslocation}/log/{$filename}-r.txt", 5 . "\n", FILE_APPEND);
			}
			elseif($_POST['rate'] == "Worst")
			{
				file_put_contents("{$fileslocation}/log/{$filename}-r.txt", 1 . "\n", FILE_APPEND);
			}
		}
		if(file_exists("{$fileslocation}/log/{$filename}-r.txt"))
		{
			$allratings = file("{$fileslocation}/log/{$filename}-r.txt");
			$rating = array_sum($allratings)/count($allratings);
		}
		else
		{
			$rating = 'Not Available';
		}
		$decimal = explode('.', $rating);
		for($i=0; $i<=$rating; $i++)
		{
			if($i+1<=$rating && $i+1<=5)
				$starrating .= '<img src="' . $starimage . '" />';
			elseif($decimal[1]>0 && $i<5)
				$starrating .= '<img src="' . $halfstarimage . '" />';
		}

		if(file_exists($thumbsdir . '/' . $filename . '_' . $resizedwidth . '.png'))
		{
			$rescaled = $thumbsdir . '/' . $filename . '_' . $resizedwidth . '.png';
		}
		else
		{
			if($watermark != '')
			{
				$rescaled = "rescale.php?d={$currdir}&i={$filename}&r=1&w={$resizedwidth}&h={$resizedheight}&t={$thumbsdir}&m={$watermark}&l={$markplacement}";
			}
			else
			{
			$rescaled = "rescale.php?d={$currdir}&i={$filename}&r=1&w={$resizedwidth}&h={$resizedheight}&t={$thumbsdir}";
			}
		}
		if(file_exists("{$currdir}/{$filename}"))
		{
			$size = getsize("{$currdir}/{$filename}");
			list($width, $height) = getimagesize($currdir . "/" . $filename);
		}
		}

		require("d2kdsys/styles/{$sysstyle}/details.inc");

	if($allowcomments)
	{

		require("d2kdsys/styles/{$sysstyle}/postcomment.inc");

		if(count($comments) > 0)
		{
		for($key = count($comments) - 1; $key >= 0; $key--)
		{

			require("d2kdsys/styles/{$sysstyle}/comments.inc");

		}
		}
		}
	?>
	<?php
	}
	elseif($mode == 'edit')
	{


####################################################################################
##-----EDIT FILE DETAILS


		$filename = $_GET['f'];

/*------------------------------------Get Name-----------------------------------*/

		$nametxt = "{$fileslocation}/info/{$filename}-n.txt";
		if(file_exists($nametxt))
		{
			$humanname = stripslashes(file_get_contents($nametxt));
		}
		else
		{
			$explodefilename = explode('.', $filename);
			$humanname = $explodefilename[0];
		}

/*------------------------------------Get Author---------------------------------*/

		$authortxt = "{$fileslocation}/info/{$filename}-a.txt";
		if(file_exists($authortxt))
		{
			$author = stripslashes(file_get_contents($authortxt));
		}
		else
		{
			$author = $defaultauthor;
		}

/*---------------------------------Get Description-------------------------------*/

		$descriptiontxt = "{$fileslocation}/info/{$filename}-d.txt";
		if(file_exists($descriptiontxt))
		{
			$description = stripslashes(file_get_contents($descriptiontxt));
		}
		else
		{
			$description = $defaultdescription;
		}

		if(file_exists($thumbsdir . '/' . $filename . '_' . $resizedwidth . '.png'))
		{
			$rescaled = $thumbsdir . '/' . $filename . '_' . $resizedwidth . '.png';
		}
		else
		{
			$rescaled = "rescale.php?d={$currdir}&i={$filename}&r=1&w={$resizedwidth}&h={$resizedheight}&t={$thumbsdir}";
		}
		$size = getsize("{$currdir}/{$filename}");

		require("d2kdsys/styles/{$sysstyle}/edit.inc");

	}
	elseif($mode == 'download')
	{


####################################################################################
##-----DOWNLOAD FILE


		$filename = $_GET['f'];
		if($pause != 1)
		{
			$pauseplural = "s";
		}

/*------------------------------------Get Name-----------------------------------*/

		$nametxt = "{$fileslocation}/info/{$filename}-n.txt";
		if(file_exists($nametxt))
		{
			$humanname = stripslashes(file_get_contents($nametxt));
		}
		else
		{
			$explodefilename = explode('.', $filename);
			$humanname = $explodefilename[0];
		}

/*-------------------------------Get Download Count------------------------------*/

		if(file_exists("{$fileslocation}/log/{$filename}.txt"))
		{
			$numdownloads = file_get_contents("{$fileslocation}/log/{$filename}.txt");
			$numdownloads++;
			file_put_contents("{$fileslocation}/log/{$filename}.txt", $numdownloads);
		}
		else
		{
			$numdownloads = 1;
			file_put_contents("{$fileslocation}/log/{$filename}.txt", $numdownloads);
		}
		if($numdownloads == 1)
		{
			$humannumdownloads = "once";
		}
		elseif($numdownloads == 2)
		{
			$humannumdownloads = "twice";
		}
		else
		{
			$humannumdownloads = $numdownloads . " times";
		}

		$size = getsize("{$currdir}/{$filename}");
		
		switch($p2p)
		{
			case 'RedSwoosh':
				$prefix = "http://edn.redswoosh.net/http://$domain/";
				break;
			case 'Dijjer':
				$prefix = "http://dijjer.org/get/http://$domain/";
				break;
		}
		$download = "{$prefix}{$currdir}/{$filename}";

		require("d2kdsys/styles/{$sysstyle}/download.inc");

	}
?>